# Module rdht_tx_add_on_nr

- Description
- Data Types
- Function Index
- Function Details

Part of replicated DHT implementation.

Copyright © 2013 Zuse Institute Berlin

Version: $Id$

Authors: Nico Kruber (`kruber@zib.de`).

## Description

Part of replicated DHT implementation. The add_on_nr operation. This "two-phase" operation uses rdht_tx_read to first read the value and then alters the tlog entry so that it appears to be a write operation from rdht_tx_write. Changes are performed in the context of the client, not on the responsible node(s)!

## Data Types

### client_key()

    client_key() = [unicode_char()]

### client_value()

    client_value() = any()

### unicode_char()

    unicode_char() = 0..55295 | 57344..65533 | 65536..1114111

## Function Index

extract_from_tlog/4 | Simulate a change on a set via read and write requests.
extract_from_tlog_feeder/4 |
work_phase/3 |

## Function Details

### work_phase/3

    work_phase(ClientPid :: pid(),
               ReqId :: rdht_tx:req_id() | rdht_tx_write:req_id(),
               Request :: api_tx:request()) ->
                  ok

### extract_from_tlog_feeder/4

    extract_from_tlog_feeder(Entry :: tx_tlog:tlog_entry(),
                             Key :: client_key(),
                             X :: client_value(),
                             EnDecode :: true) ->
                                {tx_tlog:tlog_entry(),
                                 client_key(),
                                 client_value(),
                                 EnDecode :: true}

### extract_from_tlog/4

    extract_from_tlog(Entry :: tx_tlog:tlog_entry(),
                      Key :: client_key(),
                      X :: client_value(),
                      EnDecode :: true) ->
                         {tx_tlog:tlog_entry(),
                          api_tx:numberop_result()}

Simulate a change on a set via read and write requests. Update the TLog entry accordingly.

Generated by EDoc, Feb 29 2016, 16:12:13.